#ifndef	__COMMAND_H__
#define	__COMMAND_H__

#include	<string>
#include	<vector>

/*
 * Command.h (c) Noah Roberts 2003-03-18
 * Command is in charge of parsing and executing user commands.  Commands are entered
 * in via prompt, not command line arguments, and tell the program to perform some action.
 * This is not options which actually change the behavior of the engine.
 */

class Interface;
class Board;
class Engine;
class Lawyer;
class Controller;

class Command
{
  Interface	*iface;
  Board		*board;
  Engine	*engine;
  Lawyer	*lawyer;
  Controller	*control;

  // Seperates possible command text into command and arguments...
  void parseCommand(std::string cmdText,
                    std::string &command,std::vector<std::string> &args);

  // The commands...
  void undo();
  void retract();
  void vomit();
  void _new();
  void tellog(std::vector<std::string> args);
  void setBoard(std::string cmdText, std::vector<std::string> args);
  void showHashes();

 public:
  Command(Interface *i, Board *b, Engine *e, Lawyer *l, Controller *c);

  // Public access for controler.
  bool isCommand(std::string commandText);
};

#endif /* __COMMAND_H__ */
