#ifndef __CONTROLLER_H__
#define __CONTROLLER_H__

/* Controller.h (c) Noah Roberts 2003-03-02
 * Controller is the overseer of the entire framework.  It requests input, assignes outputs,
 * initializes data structures and commands the system.  If Engine is the brain, Controller
 * is the nervous system.
 */

#include	<string>
#include	<vector>
#include	"Options.h"
class OptionsObserver;
class Engine;
class Lawyer;
class Board;
class Interface;
class Move;
class Command;

class Controller : public OptionsObserver
{
 private:
  unsigned char	computerColor;
  Board		*board;
  Lawyer	*lawyer;
  Engine	*engine;
  Interface	*interfce;
  Command	*command;

  bool cxboard;

  //std::vector<Move>	moveHistory;
  //std::string		startingPosition;
  
  bool isMove(Move &move);
 public:
  Controller(int argc, char **argv);
  ~Controller();

  /* run is the controlling procedure. */
  void run();
  Board *getBoard() { return board; }

  // OptionObserver
  void optionChanged(std::string whatOption);
};

#endif
